<?php

namespace App\Http\Controllers\API\v1;

use App\Http\Controllers\Controller;
use App\Models\EmployeeChangeSchedule;
use App\Models\User;
use App\Notifications\ChangeSchedule;
use Exception;
use Illuminate\Http\Request;
use Illuminate\Http\Response;
use Illuminate\Support\Facades\Auth;
use Illuminate\Support\Facades\DB;
use Illuminate\Support\Facades\Notification;
use Illuminate\Support\Facades\Storage;
use Illuminate\Support\Facades\Validator;
use Throwable;

class EmployeeChangeScheduleController extends Controller
{
    public function index(Request $request)
    {
        //
        $employee = Auth::user();

        $keyword = $request->input('keyword', '');
        $perPage = $request->input('per_page',PHP_INT_MAX);
        $sortBy = $request->input('sortBy', '');
        $sortType = $request->input('sortType', '');
        $data = EmployeeChangeSchedule::with([
            'recommending' => fn($recommending) => $recommending->select('employee_id', 'asa_user_id', 'firstname', 'lastname'),
            'approving'=> fn($approving) => $approving->select('employee_id', 'asa_user_id', 'firstname', 'lastname'),
            ])
            ->select(
                'id',
                'employee_id',
                'company_id',
                'dealer_id',
                'date',
                'date_to',
                'from_time',
                'to_time',
                'dayoff',
                'dayoff_date',
                'attachment',
                'description',
                'status',
                'validated_by',
                'validated_at',
                'validated',
                'deferred_reason',
                'recommending_id',
                'allow_higher_approval',
                'approver_id',
                'approved_at',
                'recommended_at',
                'created_at',
                'posted'
                )
            ->where(function ($query) use ($keyword) {
            $keyword = str_replace(" ", "%", $keyword);
            // $query->where('name', 'like', '%' . $keyword . '%');
        });

        if($employee->roles[0]['group_id'] != 1){
            $data->where(['employee_id' => $employee->employee_id]);
        }

        if (!empty($sortBy) && !empty($sortType)) {
            $data = $data->orderBy($sortBy, $sortType);
        }

        if ($request->date_created) {
            $dates = explode(' to ', $request->date_created);
            if (count($dates) == 2) {
                $data = $data->whereBetween('created_at', [$dates[0], $dates[1]]);
            }
        }

        if ($request->range) {
            $dates = explode(' to ', $request->range); 
            if (count($dates) == 2) {
                $data = $data->whereBetween('date', [$dates[0], $dates[1]]);
            } else if ((count($dates) == 1)){
                $data = $data->where('date', $dates[0]);
            }
        }
        
        if ($request->status && is_array($request->status)) {
            $data = $data->where(function ($query) use ($request) {
                if (in_array('pending', $request->status)) {
                    $query->orWhere('status', 0);
                }
        
                if (in_array('validated', $request->status)) {
                    $query->orWhere(function ($q) {
                        $q->where('status', 2)->where('validated', 1);
                    });
                }
        
                if (in_array('denied', $request->status)) {
                    $query->orWhere('status', 99)
                        ->orWhere(function ($q) {
                            $q->where('status', 2)->where('validated', 99);
                        });
                }
        
                if (in_array('for_validation', $request->status)) {
                    $query->orWhere(function ($q) {
                        $q->where('status', 2)->where('validated', 0);
                    });
                }
            });
        }  
        
        $data = $data->paginate($perPage);
        return response()->json($data);
    }

    public function getChangeScheduleList(Request $request)
    {
        //
        $employee = Auth::user();

        $keyword = $request->input('keyword', '');
        $perPage = $request->input('per_page',PHP_INT_MAX);
        $sortBy = $request->input('sortBy', '');
        $sortType = $request->input('sortType', '');
        $dealership_id = $request->input('dealership', null);
        DB::enableQueryLog();
        $data = EmployeeChangeSchedule::with([
            'recommending' => fn($recommending) => $recommending->select('employee_id', 'asa_user_id', 'firstname', 'lastname'),
            'approving'=> fn($approving) => $approving->select('employee_id', 'asa_user_id', 'firstname', 'lastname'),
            'employee'=> fn($employee) => $employee->select('employee_id', 'firstname', 'lastname'),
            ])
            ->select(
                'id',
                'employee_id',
                'company_id',
                'dealer_id',
                'date',
                'date_to',
                'from_time',
                'to_time',
                'dayoff',
                'dayoff_date',
                'attachment',
                'description',
                'status',
                'validated',
                'validated_by',
                'validated_at',
                'deferred_reason',
                'recommending_id',
                'allow_higher_approval',
                'approver_id',
                'approved_at',
                'recommended_at',
                'created_at',
                'posted'
                )
            ->where('status',2)    
            ->where(function ($query) use ($keyword) {
            $keyword = str_replace(" ", "%", $keyword);
            // $query->where('name', 'like', '%' . $keyword . '%');
        });

        if($dealership_id) $data = $data->where('dealer_id', $dealership_id);
        // $data = $data->get();
        if (!$request->date_created && !$request->range && !$request->status) {
            $data = $data->whereDate('created_at', '>=', now()->subDays(30));
        }
        
        if ($request->date_created) {
            $dates = explode(' to ', $request->date_created); // Split into start and end date
            if (count($dates) == 2) {
                $data = $data->whereBetween('created_at', [$dates[0], $dates[1]]);
            }
        }
        
        if ($request->range) {
            $dates = explode(' to ', $request->range); // Split into start and end date
            if (count($dates) == 2) {
                $data = $data->whereBetween('date', [$dates[0], $dates[1]]);
            }
        }
        
        if ($request->status && is_array($request->status)) {
            $data = $data->where(function ($query) use ($request) {
                if (in_array('pending', $request->status)) {
                    $query->orWhere('status', 0);
                }
        
                if (in_array('validated', $request->status)) {
                    $query->orWhere(function ($q) {
                        $q->where('status', 2)->where('validated', 1);
                    });
                }
        
                if (in_array('denied', $request->status)) {
                    $query->orWhere('status', 99)
                        ->orWhere(function ($q) {
                            $q->where('status', 2)->where('validated', 99);
                        });
                }
        
                if (in_array('for_validation', $request->status)) {
                    $query->orWhere(function ($q) {
                        $q->where('status', 2)->where('validated', 0);
                    });
                }
            });
        } 
        
        $data = $data->orderBy('validated', 'asc')->paginate(500);

        return response()->json(['data' => $data]);
    }

    public function store(Request $request)
    {
        // dd($request->all());
        $dayoff = ($request->dayoff && $request->dayoff !== 'null' && $request->dayoff !== 'false' && trim($request->dayoff) !== '' ? 1 : 0);

        $user = Auth::user();

        $validator = Validator::make($request->all(), [
            'date' => "required|date",
            'from_time' => $dayoff ? "" : "required",
            'to_time' => $dayoff ? "" :"required",
        ]);

        /** If validation fails return with error message */
        if ($validator->fails()) {
            $errors = $validator->errors();
            $first = $errors->getMessages();
            return response()->json([
                'status'  => false,
                'message' => (reset($first))[0],
                'errors'  => $errors
            ], Response::HTTP_UNPROCESSABLE_ENTITY);
        }

        DB::connection()->beginTransaction();

        try {
            $allow_higher_approval = ($request->allow_higher_approval && $request->allow_higher_approval !== 'null' && $request->allow_higher_approval !== 'false' && trim($request->allow_higher_approval) !== '' ? 1 : 0);

            $attachmentName = $this->handleAttachment($request);
    
            $Status = EmployeeChangeSchedule::create([
                'employee_id' => $user->employee_id,
                'company_id' => $user->employees->company_id,
                'dealer_id' => $user->employees->dealer_id,
                'date' => $request->date,
                'date_to' => $request->date_to != 'null' ? $request->date_to : $request->date,
                'from_time' => $request->from_time,
                'to_time' => $request->to_time,
                'dayoff' => $dayoff,
                'dayoff_date' => $request->dayoff_date == 'null' ? null : $request->dayoff_date,
                'description' => $request->description,
                'attachment' => $attachmentName,
                'allow_higher_approval' => $allow_higher_approval,
                'recommending_id' => $request->recommending_id[0],
                'approver_id' => (($request->approver_id[0] ?? null) && $allow_higher_approval)
                    ? ($request->approver_id[0] ?? null)
                    : ($request->recommending_id[0] ?? null),
                'status' => 0,
            ]);

            DB::connection()->commit();

            // Load the relationships
            $Status->load(['employee']);

            // $email_to = $this->getEmployeeEmailData($request->recommending_id);

            // Notification::send($email_to, new ChangeSchedule($Status));

            return response()->json([
                'status'  => true,
                'message' => 'Saved successfully!',
                'data'    => $Status
            ],201);

        } catch (Throwable $e) {

            DB::connection()->rollback();
            return response()->json([
                'status'  => false,
                'message' => 'Unable to process request. Please try again.',
                'data'    => $e->getMessage()
            ], 422);
        }
    }

    public function handleAttachment(Request $request)
    {
        if ($request->hasFile('attachment')) {
            $image = $request->file('attachment');
            $attachmentName = time() . '_' . $image->getClientOriginalName();
            $path = "employee-overtime/" . $attachmentName;
            if (Storage::disk('local')->put($path, file_get_contents($image))) {
                return $attachmentName;
            }
            throw new Exception('Unable to process attachment.');
        }
        return '';
    }

    public function update(Request $request)
    {
        $id = $request->id;

        $data = EmployeeChangeSchedule::where('id', $id)->first();

        $user = Auth::user();

        $dayoff = ($request->dayoff && $request->dayoff !== 'null' && $request->dayoff !== 'false' && trim($request->dayoff) !== '' ? 1 : 0);

        $validator = Validator::make($request->all(), [
            'date' => "required|date",
            'from_time' => $dayoff ? "" : "required",
            'to_time' => $dayoff ? "" :"required",
        ]);

        /** If validation fails return with error message */
        if ($validator->fails()) {
            $errors = $validator->errors();
            $first = $errors->getMessages();
            return response()->json([
                'status'  => false,
                'message' => (reset($first))[0],
                'errors'  => $errors
            ], Response::HTTP_UNPROCESSABLE_ENTITY);
        }

        $attachment_name = $request->attachment;

        if($data->attachment != $request->attachment)
        {
            $attachment_file_path = 'employee-overtime/' . $data->attachment;
            if(Storage::exists($attachment_file_path))
            {
                Storage::delete($attachment_file_path);
            }

            if($request->hasFile('attachment')) {
                $image      = $request->file('attachment');
                $attachment_name  = time().'_'.$image->getClientOriginalName();
                $path       = "employee-overtime/".$attachment_name;
                if(!Storage::disk('local')->put($path, file_get_contents($image)))
                {
                    return response()->json(['message'=> "Failed to upload attachment"],304);
                }
            }
            else
            {
                $attachment_name = null;
            }
        }

        DB::connection()->beginTransaction();


        try {
            $allow_higher_approval = ($request->allow_higher_approval && $request->allow_higher_approval !== 'null' && $request->allow_higher_approval !== 'false' && trim($request->allow_higher_approval) !== '' ? 1 : 0);

            $data->employee_id = $user->employee_id;
            $data->date = $request->date;
            $data->date_to = $request->date_to != 'null'  ? $request->date_to : $request->date;
            $data->from_time = $request->from_time;
            $data->to_time = $request->to_time;
            $data->dayoff = $dayoff;
            $data->dayoff_date = $request->dayoff_date == null || $request->dayoff_date == '' || $request->dayoff_date == 'null' ? NULL : $request->dayoff_date;
            $data->description = $request->description == null || $request->description == '' || $request->description == 'null' ? NULL : $request->description;
            $data->attachment = $attachment_name;
            $data->recommending_id = $request->recommending_id[0];
            $data->allow_higher_approval = $allow_higher_approval;
            $data->approver_id = $request->approver_id[0] && $allow_higher_approval ? $request->approver_id[0] : $request->recommending_id[0];
            $data->save();


            DB::connection()->commit();

            return response()->json([
                'status'  => true,
                'message' => 'Saved successfully!',
                'data'    => $data
            ],201);

        } catch (Throwable $e) {

            DB::connection()->rollback();
            return response()->json([
                'status'  => false,
                'message' => 'Unable to process request. Please try again.',
                'data'    => $e->getMessage()
            ], 422);
        }
    }

    public function destroy(int $id)
    {
        $data = EmployeeChangeSchedule::find($id);
        if(!$data)
        {
            return response()->json(['message' => "Record not found!"],204);
        }
        DB::connection()->beginTransaction();
        $data->delete();
        DB::connection()->commit();
        return response()->json(['message' => "Record successfully deleted!"],201);
    }

    public function getEmployeeEmailData($id){
        return User::where('employee_id', '=', $id)->first();
    }
}
